.\"	$NetBSD: boot.8,v 1.11 2003/08/07 10:31:22 agc Exp $
.\"
.\" Copyright (c) 1990, 1991 The Regents of the University of California.
.\" All rights reserved.
.\"
.\" This code is derived from software contributed to Berkeley by
.\" the Systems Programming Group of the University of Utah Computer
.\" Science Department.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"	From:
.\"	@(#)boot_hp300.8	8.2 (Berkeley) 4/19/94
.\"
.Dd April 8, 2003
.Dt BOOT 8 amiga
.Os
.Sh NAME
.Nm boot
.Nd
system bootstrapping procedures
.Sh DESCRIPTION
.Ss Power fail and crash recovery
When the
.Nx
kernel is booted normally (using one of the two methods discussed below),
it initializes itself and proceeds to boot the system.
An automatic consistency check of the file systems takes place,
and unless this fails, the system comes up to multi-user operations.
The proper way to shut the system down is with the
.Xr shutdown 8
command.
.Pp
If the system crashes, it will enter the kernel debugger,
.Xr ddb 4 ,
if it is configured in the kernel.
If the debugger is not present,
or the debugger is exited, the system will attempt a dump to the
configured dump device (which will be automatically recovered with
.Xr savecore 8
during the next boot cycle).
After the dump is complete (successful
or not), the system will attempt a reboot.
.Ss Booting NetBSD using the bootloader
When a bootable
.Nx
partition is created by means of HDTOOLBOX or another RDB editing program
and a bootblock has been copied there by
.Xr installboot 8
and the boot priority of the
.Nx
partition is either the highest or the
.Nx
partition is selected by means of the boot menu,
the Amiga ROM will automatically start the
.Nx
bootloader.
By default it will, after a short timeout, load the kernel image
.Pa /netbsd
and attempt to boot it into multi-user mode.
This behaviour can be changed by
typing in an alternate command sequence.
The command line looks like:
.Bd -ragged -offset indent
.Ar kernel-path
.Op Fl abknpqstvADZ
.Op Fl c Ar model
.Op Fl m Ar memsize
.Op Fl n Ar memsegments
.Op Fl I Ar mask
.Op Fl S Ar amount
.Op Fl T Ar amount
.Ed
.Pp
.Bl -tag -width flag
.It kernel-path
This gives you the opportunity to boot another kernel, say:
.Pa /netbsd.old .
The default is
.Pa /netbsd .
.It Fl a
Autoboot into multi-user mode (default).
.It Fl b
Prompt for the root file system device, the system crash dump
device, and the path to
.Xr init 8 .
.It Fl c Ar model
force machine
.Ar model .
Use 32000+(Qlogic chip revision) for the DraCo.
.It Fl k
Reserve the first 4M of fastmem.
.It Fl m Ar memsize
Force fastmem size to be
.Ar memsize
kBytes.
.It Fl n
maximum number of
.Ar segments
of memory to use, encoded as follows: 0 (default): 1 segment, 1:
2 segments, 2: 3 or more segments.
.It Fl p
Select kernel load segment by priority instead of size.
.It Fl q
Boot in quiet mode.
.It Fl s
Boot into single-user mode.
.It Fl v
Boot in verbose mode.
.It Fl D
Enter the kernel debugger (best used with -S)
.It Fl I Ar mask
inhibit sync negotiation as follows: The
.Ar mask
is a bitmap expressed in C notation (e.g., 0xff)
with 4*8bits, each bit, if set to 1, disabling sync negotiation for
the corresponding target.
Note that this only applies to (some of the)
real SCSI busses, but not, e.g., to internal IDE.
The bytes are used up
from right to left by SCSI bus drivers using this convention.
.It Fl S
Load the  kernel symbols
.El
.Ss Booting NetBSD using the loadbsd program
When you want (or have to) start
.Nx
from AmigaOS, you have to use the
.Ic loadbsd
program that is supplied in the utils directory of the distribution.
The loadbsd command line specification is:
.Bd -ragged -offset indent
.Nm loadbsd
.Op Fl abknpstADZ
.Op Fl c Ar model
.Op Fl m Ar memsize
.Op Fl n Ar memsegments
.Op Fl I Ar mask
.Op Fl S Ar amount
.Op Fl T Ar amount
.Ar kernel-path
.Ed
.Pp
Description of options:
.Bl -tag -width flag
.It Fl a
Autoboot into multi-user mode.
.It Fl b
Prompt for the root file system device, the system crash dump
device, and the path to
.Xr init 8 .
.It Fl c
force machine model.
.It Fl k
Reserve the first 4M of fastmem.
.It Fl m
Force fastmem size to be
.Ar memsize
kBytes.
.It Fl n
maximum number of
.Ar segments
of memory to use, encoded as follows: 0 (default): 1 segment, 1:
2 segments, 2: 3 or more segments.
.It Fl p
Select kernel load segment by priority instead of size.
.It Fl s
Boot into single-user mode.
.It Fl t
Test loading of the kernel but don't start
.Nx .
.It Fl A
enable AGA modes.
.It Fl D
Enter the kernel debugger after booting.
Best with
.Fl S .
.It Fl I Ar mask
inhibit sync negotiation as follows: The
.Ar mask
is a bitmap expressed in hexadecimal (e.g., ff)
with 4*8bits, each bit, if set to 1, disabling sync negotiation for
the corresponding target.
Note that this only applies to (some of the)
real SCSI busses, but not, e.g., to internal IDE.
The bytes are used up
from right to left by SCSI bus drivers using this convention.
.It Fl S
include kernel debug symbols (for use by -D).
.It Fl Z
Force load via chip memory.
Won't work if kernel is larger than the chip memory size or on the
DraCo.
.El
.Pp
Note: Because the loadbsd program can only read kernels from a AmigaOS
filesystem, the file
.Ar /netbsd
is often not the same as the actual kernel booted.
This can cause some programs to fail.
However, note that you can use third-party Berkeley
filesystems such as bffs to access the
.Nx
root partition from AmigaOS.
.Sh FILES
.Bl -tag -width /usr/mdec/bootxx_ffs -compact
.It Pa /netbsd
system kernel
.It Pa /usr/mdec/bootxx_ffs
RDB device primary boot block
.It Pa /usr/mdec/bootxx_fd
floppy disk primary boot block
.It Pa /usr/mdec/boot.amiga
secondary bootstrap
.It Pa /boot.amiga
secondary bootstrap (installed)
.El
.Sh SEE ALSO
.Xr ddb 4 ,
.Xr fsck_ffs 8 ,
.Xr installboot 8 ,
.Xr newfs 8 ,
.Xr savecore 8 ,
.Xr shutdown 8
.Sh BUGS
Due to code size restrictions, you can't currently use an old-style file
system (created with
.Xr newfs 8
-O
or with
.Nx 0.9 )
with the boot block.
You can use
.Ic loadbsd
to boot from AmigaOS, or upgrade the file system with
.Ar fsck_ffs -c 2 .
